#!/usr/bin/perl

$BAUD=shift;
defined($BAUD) || die("Must specify a baud rate");
#$BAUD=9600;
#$FOSC=14318180;
#$FOSC=4*1000*1000;
$FOSC=shift;
defined($FOSC) || die("Must specify a clock speed in hz");

$HI=shift;
defined($HI)	|| die("Must specify hi or lo speed(0/1)");
#$HI=1;

if($HI)	{	$FACTOR=16.0;	}
else	{	$FACTOR=64.0;	}

$val=($FOSC/($BAUD*$FACTOR))-1;
$val=sprintf("%d",$val);
$NBAUD=$FOSC/($FACTOR*($val+1.0));

printf("Clock(%d)\t",$FOSC);

if($val>255)	{	printf("Baud(%d) OUT OF RANGE\n",$BAUD);	}
else
{
	printf("Baud(%d) Val(%d) ",$BAUD,$val);
	printf("Nbaud(%2f) ",$NBAUD);
	printf("Error(%.2f%%)\n", (($NBAUD-$BAUD)/$BAUD)*100.0);
}

exit 0;
