/**
 * tsmtypes.h -- defines for integers of specific sizes.
 * Copyright (C) 2007 Tyler Montbriand
 * monttyle@burningsmell.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef __TSMTYPES_H__
#define __TSMTYPES_H__

typedef unsigned char	Uint8;
typedef unsigned int	Uint16;
typedef unsigned long	Uint32;

typedef char		Sint8;
typedef int		Sint16;
typedef long		Sint32;

#endif/*__TSMTYPES_H__*/
